"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  AbstractAction: () => AbstractAction,
  AbstractHandler: () => AbstractHandler,
  AbstractMessageAction: () => AbstractMessageAction,
  AbstractSubscription: () => AbstractSubscription,
  AbstractTypeFactory: () => AbstractTypeFactory,
  AbstractValidator: () => AbstractValidator,
  ActionTakenByUserValidator: () => ActionTakenByUserValidator,
  BadBotHandler: () => BadBotHandler,
  CreateFollowAction: () => CreateFollowAction,
  CreateLikeAction: () => CreateLikeAction,
  CreateReskeetAction: () => CreateReskeetAction,
  CreateSkeetAction: () => CreateSkeetAction,
  CreateSkeetMessageAction: () => CreateSkeetMessageAction,
  CreateSkeetRecordFactory: () => CreateSkeetRecordFactory,
  CreateSkeetWithGeneratedTextAction: () => CreateSkeetWithGeneratedTextAction,
  DebugLog: () => DebugLog,
  DebugLogAction: () => DebugLogAction,
  DeleteFollowAction: () => DeleteFollowAction,
  DeleteLikeAction: () => DeleteLikeAction,
  DeleteReskeetAction: () => DeleteReskeetAction,
  DeleteSkeetAction: () => DeleteSkeetAction,
  FunctionAction: () => FunctionAction,
  GoodBotHandler: () => GoodBotHandler,
  HandlerAgent: () => HandlerAgent,
  InputContainsValidator: () => InputContainsValidator,
  InputEqualsValidator: () => InputEqualsValidator,
  InputIsCommandValidator: () => InputIsCommandValidator,
  InputStartsWithValidator: () => InputStartsWithValidator,
  IntervalSubscription: () => IntervalSubscription,
  IsBadBotValidator: () => IsBadBotValidator,
  IsFourTwentyValidator: () => IsFourTwentyValidator,
  IsGoodBotValidator: () => IsGoodBotValidator,
  IsNewPost: () => IsNewPost,
  IsReplyValidator: () => IsReplyValidator,
  IsSpecifiedTimeValidator: () => IsSpecifiedTimeValidator,
  JetstreamAccountFactory: () => JetstreamAccountFactory,
  JetstreamCommitFactory: () => JetstreamCommitFactory,
  JetstreamEventFactory: () => JetstreamEventFactory,
  JetstreamIdentityFactory: () => JetstreamIdentityFactory,
  JetstreamRecordFactory: () => JetstreamRecordFactory,
  JetstreamSubjectFactory: () => JetstreamSubjectFactory,
  JetstreamSubscription: () => JetstreamSubscription,
  LikeByUser: () => LikeByUser,
  LikeOfPost: () => LikeOfPost,
  LikeOfUser: () => LikeOfUser,
  LogInputTextAction: () => LogInputTextAction,
  LogMessageAction: () => LogMessageAction,
  MessageHandler: () => MessageHandler,
  NewFollowFromUserValidator: () => NewFollowFromUserValidator,
  NewFollowerForUserValidator: () => NewFollowerForUserValidator,
  NewSkeetRecordFactory: () => NewSkeetRecordFactory,
  OfflineHandler: () => OfflineHandler,
  OrValidator: () => OrValidator,
  PostLikesValidator: () => PostLikesValidator,
  PostedByUserValidator: () => PostedByUserValidator,
  ReplyFactory: () => ReplyFactory,
  ReplyToSkeetAction: () => ReplyToSkeetAction,
  ReplyToSkeetWithGeneratedTextAction: () => ReplyToSkeetWithGeneratedTextAction,
  ReplyingToBotValidator: () => ReplyingToBotValidator,
  RepostByUser: () => RepostByUser,
  RepostOfPost: () => RepostOfPost,
  RepostOfUser: () => RepostOfUser,
  SimpleFunctionValidator: () => SimpleFunctionValidator,
  TestAction: () => TestAction,
  TestFactory: () => TestFactory,
  TestHandler: () => TestHandler,
  TestMessageAction: () => TestMessageAction,
  TestMessageHandler: () => TestMessageHandler,
  TestValidator: () => TestValidator,
  UserFollowedValidator: () => UserFollowedValidator,
  containsNumbers: () => containsNumbers,
  containsPunctuation: () => containsPunctuation,
  containsSpaces: () => containsSpaces,
  debugLog: () => debugLog,
  flattenTextUpdated: () => flattenTextUpdated,
  getHumanReadableDateTimeStamp: () => getHumanReadableDateTimeStamp,
  getTimezonesWhereItIsAGivenTime: () => getTimezonesWhereItIsAGivenTime,
  isBadBotResponse: () => isBadBotResponse,
  isGoodBotResponse: () => isGoodBotResponse,
  isTimeInHHMMFormat: () => isTimeInHHMMFormat,
  nowDateTime: () => nowDateTime,
  removeNumbers: () => removeNumbers,
  removePunctuation: () => removePunctuation,
  removeSpaces: () => removeSpaces,
  trimCommandInput: () => trimCommandInput
});
module.exports = __toCommonJS(src_exports);

// src/utils/time-utils.ts
var import_moment_timezone = __toESM(require("moment-timezone"));
function getHumanReadableDateTimeStamp(datetime, timezone = "America/Chicago") {
  const dateObject = new Date(datetime);
  return dateObject.toLocaleString("en-US", {
    timeZone: timezone,
    hour12: true,
    // Use 24-hour time format
    year: "numeric",
    month: "long",
    day: "numeric",
    hour: "2-digit",
    minute: "2-digit"
  });
}
function nowDateTime() {
  return (/* @__PURE__ */ new Date()).toLocaleString("en-US", {
    timeZone: "America/Chicago",
    hour12: true,
    // Use 24-hour time format
    year: "numeric",
    month: "numeric",
    day: "numeric",
    hour: "2-digit",
    minute: "2-digit"
  });
}
function getTimezonesWhereItIsAGivenTime(timeToCheck) {
  const format = "HH:mm";
  const allTimezones = import_moment_timezone.default.tz.names();
  const tz = [];
  allTimezones.forEach((timezone) => {
    const currentTimeInTimezone = import_moment_timezone.default.tz(timezone).format(format);
    if (currentTimeInTimezone === timeToCheck) {
      tz.push(timezone);
    }
  });
  return tz;
}
function isTimeInHHMMFormat(time) {
  const pattern = /^(0[0-9]|1[0-9]|2[0-3]):[0-5][0-9]$/;
  return pattern.test(time);
}

// src/utils/DebugLog.ts
var DebugLog = class _DebugLog {
  static debug(action, message) {
    _DebugLog.log(action, message, "debug");
  }
  static info(action, message) {
    _DebugLog.log(action, message, "info");
  }
  static warn(action, message) {
    _DebugLog.log(action, message, "warn");
  }
  static error(action, message) {
    _DebugLog.log(action, message, "error");
  }
  static log(action, message, level = "debug") {
    const debug = process.env.DEBUG_LOG_ACTIVE === "true";
    const debugLevel = process.env.DEBUG_LOG_LEVEL ?? "error";
    const debugLevels = {
      error: ["error"],
      warn: ["error", "warn"],
      info: ["error", "warn", "info"],
      debug: ["error", "warn", "info", "debug"]
    };
    if (debug && debugLevels[debugLevel].includes(level)) {
      console.log(
        `${nowDateTime()} | ${action} | ${level.toUpperCase()} | ${message}`
      );
    }
  }
};

// src/handlers/AbstractHandler.ts
var AbstractHandler = class {
  constructor(validators, actions, handlerAgent) {
    this.validators = validators;
    this.actions = actions;
    this.handlerAgent = handlerAgent;
  }
  HANDLER_NAME = "Abstract Handler";
  static make(...args) {
    throw new Error("Method Not Implemented! Use constructor.");
  }
  async shouldTrigger(...args) {
    const willTrigger = true;
    for (const validator of this.validators) {
      const response = await validator.shouldTrigger(
        this.handlerAgent,
        ...args
      );
      if (!response) {
        return false;
      }
    }
    return willTrigger;
  }
  async runActions(...args) {
    for (const action of this.actions) {
      await action.handle(this.handlerAgent, ...args);
    }
  }
  //@ts-ignore
  async handle(handlerAgent, ...args) {
    const shouldTrigger = await this.shouldTrigger(...args);
    if (shouldTrigger) {
      try {
        await this.runActions(...args);
      } catch (exception) {
        DebugLog.error(this.HANDLER_NAME, exception);
      }
    }
  }
};

// src/handlers/message-handlers/MessageHandler.ts
var MessageHandler = class _MessageHandler extends AbstractHandler {
  constructor(validators, actions, handlerAgent) {
    super(validators, actions, handlerAgent);
    this.validators = validators;
    this.actions = actions;
    this.handlerAgent = handlerAgent;
    return this;
  }
  HANDLER_NAME = "Message Handler";
  static getUriFromMessage(handlerAgent, message) {
    return handlerAgent.generateURIFromCreateMessage(message);
  }
  static getCidFromMessage(handlerAgent, message) {
    return message.commit.cid;
  }
  static generateReplyFromMessage(handlerAgent, message) {
    return handlerAgent.generateReplyFromMessage(message);
  }
  static make(validators, actions, handlerAgent) {
    return new _MessageHandler(validators, actions, handlerAgent);
  }
};

// src/handlers/TestHandler.ts
var TestHandler = class extends AbstractHandler {
  constructor(validators, actions, handlerAgent) {
    super(validators, actions, handlerAgent);
    return this;
  }
  async handle(handlerAgent, ...args) {
    const shouldTrigger = await this.shouldTrigger(...args);
    if (shouldTrigger) {
      try {
        await this.runActions(...args);
      } catch (exception) {
        DebugLog.error("Message Handler", exception);
      }
    }
  }
};

// src/handlers/message-handlers/TestMessageHandler.ts
var TestMessageHandler = class extends MessageHandler {
  constructor(validators, actions, handlerAgent) {
    super(validators, actions, handlerAgent);
    return this;
  }
  async handle(handlerAgent, message) {
    const shouldTrigger = await this.shouldTrigger(message);
    if (shouldTrigger) {
      try {
        await this.runActions(message);
      } catch (exception) {
        DebugLog.error("Message Handler", exception);
      }
    }
  }
};

// src/utils/text-utils.ts
function flattenTextUpdated(triggerKey, input) {
  if (!containsNumbers(triggerKey)) {
    input = removeNumbers(input);
  }
  if (!containsPunctuation(triggerKey)) {
    input = removePunctuation(input);
  }
  if (!containsSpaces(triggerKey)) {
    input = removeSpaces(input);
  }
  return input.toLowerCase();
}
function removePunctuation(input) {
  return input.replace(/[.,\/#!$?%\^&\*;:{}=\-_`~()]/g, "").replace(/\s{2,}/g, " ");
}
function removeNumbers(input) {
  return input.replace(/[0-9]/g, "");
}
function removeSpaces(input) {
  return input.replaceAll(" ", "");
}
function containsNumbers(str) {
  return /\d/.test(str);
}
function containsPunctuation(str) {
  return /\p{P}/gu.test(str);
}
function containsSpaces(str) {
  return str.includes(" ");
}
function trimCommandInput(input, command) {
  input = input.toLowerCase();
  command = command.toLowerCase();
  if (input.startsWith(`!${command}`)) {
    return input.replace(`!${command}`, "").trim().toLowerCase();
  } else if (input.startsWith(`${command}!`)) {
    return input.replace(`${command}!`, "").trim().toLowerCase();
  } else {
    return false;
  }
}
function isGoodBotResponse(input) {
  const positiveConnotationWords = [
    "great",
    "good",
    "fantastic",
    "excellent",
    "awesome",
    "positive",
    "amazing",
    "incredible",
    "super"
  ];
  const words = removePunctuation(input.toLowerCase()).split(" ");
  if (words[1] === "bot") {
    if (positiveConnotationWords.includes(words[0])) {
      return true;
    }
  }
  return input.toLowerCase().includes("thank you");
}
function isBadBotResponse(input) {
  const negativeConnotationWords = [
    "bad",
    "dumb",
    "stupid",
    "useless",
    "annoying",
    "shitty"
  ];
  const words = removePunctuation(input.toLowerCase()).split(" ");
  if (words[1] === "bot") {
    if (negativeConnotationWords.includes(words[0])) {
      return true;
    }
  }
  return false;
}

// src/validations/AbstractValidator.ts
var AbstractValidator = class {
  negate = false;
  constructor() {
  }
  static make(...args) {
    throw new Error("Method Not Implemented! Use constructor.");
  }
  not() {
    this.negate = true;
    return this;
  }
  // @ts-ignore
  async shouldTrigger(handlerAgent, ...args) {
    const valid = await this.handle(handlerAgent, ...args);
    return this.negate ? !valid : valid;
  }
};

// src/validations/message-validators/AbstractMessageValidator.ts
var AbstractMessageValidator = class extends AbstractValidator {
  constructor() {
    super();
  }
  static make(...args) {
    throw new Error("Method Not Implemented! Use constructor.");
  }
  getTextFromPost(message) {
    const createSkeetMessage = message?.commit?.record;
    const text = createSkeetMessage?.text;
    return text;
  }
  // @ts-ignore
  async shouldTrigger(handlerAgent, message) {
    const valid = await this.handle(handlerAgent, message);
    return this.negate ? !valid : valid;
  }
};

// src/validations/message-validators/BotValidators.ts
var IsGoodBotValidator = class _IsGoodBotValidator extends AbstractMessageValidator {
  constructor() {
    super();
  }
  static make() {
    return new _IsGoodBotValidator();
  }
  async handle(handlerAgent, message) {
    if (!handlerAgent.hasPostReply(message)) {
      return false;
    }
    const replyingToDid = handlerAgent.getDIDFromUri(
      // @ts-ignore
      message.commit.record.reply?.parent.uri
    );
    const isReplyToBot = handlerAgent.getDid === replyingToDid && message.commit.collection == "app.bsky.feed.post";
    return isGoodBotResponse(this.getTextFromPost(message)) && isReplyToBot;
  }
};
var IsBadBotValidator = class _IsBadBotValidator extends AbstractMessageValidator {
  constructor() {
    super();
  }
  static make() {
    return new _IsBadBotValidator();
  }
  async handle(handlerAgent, message) {
    if (!handlerAgent.hasPostReply(message)) {
      return false;
    }
    const replyingToDid = handlerAgent.getDIDFromUri(
      // @ts-ignore
      message.commit.record.reply?.parent.uri
    );
    const isReplyToBot = handlerAgent.getDid === replyingToDid && message.commit.collection == "app.bsky.feed.post";
    return isBadBotResponse(this.getTextFromPost(message)) && isReplyToBot;
  }
};

// src/actions/AbstractAction.ts
var AbstractAction = class {
  constructor() {
  }
  static make(...args) {
    throw new Error("Method not implemented! Use constructor!");
  }
  static getStringOrFunctionReturn(stringOrFunction, handlerAgent, ...args) {
    if (typeof stringOrFunction == "function") {
      return stringOrFunction(handlerAgent, ...args);
    } else {
      return stringOrFunction;
    }
  }
};
var TestAction = class extends AbstractAction {
  async handle(handlerAgent) {
    DebugLog.info("Working", "working");
  }
};

// src/actions/standard-bsky-actions/LikeActions.ts
var CreateLikeAction = class _CreateLikeAction extends AbstractAction {
  constructor(skeetUri, skeetCid) {
    super();
    this.skeetUri = skeetUri;
    this.skeetCid = skeetCid;
  }
  static make(skeetUri, skeetCid) {
    return new _CreateLikeAction(skeetUri, skeetCid);
  }
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  async handle(handlerAgent, ...args) {
    const uri = AbstractAction.getStringOrFunctionReturn(
      this.skeetUri,
      handlerAgent,
      ...args
    );
    const cid = AbstractAction.getStringOrFunctionReturn(
      this.skeetCid,
      handlerAgent,
      ...args
    );
    await handlerAgent.likeSkeet(uri, cid);
  }
};
var DeleteLikeAction = class _DeleteLikeAction extends AbstractAction {
  constructor(skeetUri) {
    super();
    this.skeetUri = skeetUri;
  }
  static make(skeetUri) {
    return new _DeleteLikeAction(skeetUri);
  }
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  async handle(handlerAgent, ...args) {
    const uri = AbstractAction.getStringOrFunctionReturn(
      this.skeetUri,
      handlerAgent,
      ...args
    );
    await handlerAgent.unlikeSkeet(uri);
  }
};

// src/actions/LoggingActions.ts
var LogInputTextAction = class _LogInputTextAction extends AbstractAction {
  constructor(logText) {
    super();
    this.logText = logText;
  }
  static make(logText) {
    return new _LogInputTextAction(logText);
  }
  // eslint-disable-next-line @typescript-eslint/no-unused-vars,  @typescript-eslint/no-explicit-any
  async handle(handlerAgent, ...args) {
    const text = AbstractAction.getStringOrFunctionReturn(
      this.logText,
      handlerAgent,
      ...args
    );
    console.log(text);
  }
};
var DebugLogAction = class _DebugLogAction extends AbstractAction {
  constructor(action, message, level = "info") {
    super();
    this.action = action;
    this.message = message;
    this.level = level;
  }
  static make(action, message, level = "info") {
    return new _DebugLogAction(action, message, level);
  }
  async handle(handlerAgent, ...args) {
    DebugLog.log(
      AbstractAction.getStringOrFunctionReturn(
        this.action,
        handlerAgent,
        ...args
      ),
      AbstractAction.getStringOrFunctionReturn(
        this.message,
        handlerAgent,
        ...args
      ),
      this.level
    );
  }
};

// src/actions/standard-bsky-actions/SkeetActions.ts
var CreateSkeetAction = class _CreateSkeetAction extends AbstractAction {
  constructor(skeetText, skeetReply = void 0) {
    super();
    this.skeetText = skeetText;
    this.skeetReply = skeetReply;
  }
  static make(skeetText, skeetReply = void 0) {
    return new _CreateSkeetAction(skeetText, skeetReply);
  }
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  async handle(handlerAgent, ...args) {
    const text = AbstractAction.getStringOrFunctionReturn(
      this.skeetText,
      handlerAgent,
      ...args
    );
    let reply = void 0;
    if (this.skeetReply !== void 0) {
      if (typeof this.skeetReply == "function") {
        reply = this.skeetReply(handlerAgent, ...args);
      } else {
        reply = this.skeetReply;
      }
    }
    await handlerAgent.createSkeet(text, reply);
  }
};
var DeleteSkeetAction = class _DeleteSkeetAction extends AbstractAction {
  constructor(skeetUri) {
    super();
    this.skeetUri = skeetUri;
  }
  static make(skeetUri) {
    return new _DeleteSkeetAction(skeetUri);
  }
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  async handle(handlerAgent, ...args) {
    const uri = AbstractAction.getStringOrFunctionReturn(
      this.skeetUri,
      handlerAgent,
      ...args
    );
    await handlerAgent.deleteSkeet(uri);
  }
};

// src/handlers/message-handlers/premade-handlers/GoodBotHandler.ts
var GoodBotHandler = class _GoodBotHandler extends MessageHandler {
  constructor(handlerAgent, response = "Thank you \u{1F979}") {
    super(
      [IsGoodBotValidator.make()],
      [
        CreateSkeetAction.make(
          response,
          MessageHandler.generateReplyFromMessage
        ),
        CreateLikeAction.make(
          MessageHandler.getUriFromMessage,
          MessageHandler.getCidFromMessage
        ),
        DebugLogAction.make("GOOD BOT", `Told I'm good :)`)
      ],
      handlerAgent
    );
    this.handlerAgent = handlerAgent;
    this.response = response;
  }
  static make(handlerAgent, response = void 0) {
    return new _GoodBotHandler(handlerAgent, response);
  }
  async handle(handlerAgent, message) {
    return super.handle(this.handlerAgent, message);
  }
};

// src/handlers/message-handlers/premade-handlers/BadBotHandler.ts
var BadBotHandler = class _BadBotHandler extends MessageHandler {
  constructor(handlerAgent, response = "I'm sorry \u{1F613}") {
    super(
      [IsBadBotValidator.make()],
      [
        CreateSkeetAction.make(
          response,
          MessageHandler.generateReplyFromMessage
        ),
        CreateLikeAction.make(
          MessageHandler.getUriFromMessage,
          MessageHandler.getCidFromMessage
        ),
        DebugLogAction.make("BAD BOT", `Told I'm bad :(`)
      ],
      handlerAgent
    );
    this.handlerAgent = handlerAgent;
    this.response = response;
  }
  static make(handlerAgent, response = void 0) {
    return new _BadBotHandler(handlerAgent, response);
  }
  // TODO Update to use JetstreamEventCommit
  async handle(handlerAgent, message) {
    return super.handle(this.handlerAgent, message);
  }
};

// src/validations/message-validators/post/StringValidators.ts
var InputIsCommandValidator = class _InputIsCommandValidator extends AbstractMessageValidator {
  constructor(triggerKey, strict = true) {
    super();
    this.triggerKey = triggerKey;
    this.strict = strict;
  }
  static make(triggerKey, strict = void 0) {
    return new _InputIsCommandValidator(triggerKey, strict);
  }
  async handle(handlerAgent, message) {
    if (this.strict) {
      const input = this.getTextFromPost(message);
      return input.startsWith(`!${this.triggerKey}`) || input.startsWith(`${this.triggerKey}!`);
    } else {
      const input = this.getTextFromPost(message).toLowerCase();
      const lowerCaseTriggerKey = this.triggerKey.toLowerCase();
      return input.startsWith(`!${lowerCaseTriggerKey}`) || input.startsWith(`${lowerCaseTriggerKey}!`);
    }
  }
};
var InputStartsWithValidator = class _InputStartsWithValidator extends AbstractMessageValidator {
  constructor(triggerKey, strict = false) {
    super();
    this.triggerKey = triggerKey;
    this.strict = strict;
  }
  static make(triggerKey, strict = void 0) {
    return new _InputStartsWithValidator(triggerKey, strict);
  }
  async handle(handlerAgent, message) {
    const input = this.getTextFromPost(message);
    if (this.strict) {
      return input.startsWith(this.triggerKey);
    }
    const flatText = flattenTextUpdated(this.triggerKey, input);
    return flatText.startsWith(this.triggerKey);
  }
};
var InputContainsValidator = class _InputContainsValidator extends AbstractMessageValidator {
  constructor(triggerKey, strict = false) {
    super();
    this.triggerKey = triggerKey;
    this.strict = strict;
  }
  static make(triggerKey, strict = void 0) {
    return new _InputContainsValidator(triggerKey, strict);
  }
  async handle(handlerAgent, message) {
    const input = this.getTextFromPost(message);
    if (this.strict) {
      return input.includes(this.triggerKey);
    }
    const flatText = flattenTextUpdated(this.triggerKey, input);
    return flatText.includes(this.triggerKey);
  }
};
var InputEqualsValidator = class _InputEqualsValidator extends AbstractMessageValidator {
  constructor(triggerKey) {
    super();
    this.triggerKey = triggerKey;
  }
  static make(triggerKey) {
    return new _InputEqualsValidator(triggerKey);
  }
  async handle(handlerAgent, message) {
    const input = this.getTextFromPost(message);
    return input === this.triggerKey;
  }
};

// src/actions/message-actions/AbstractMessageAction.ts
var AbstractMessageAction = class extends AbstractAction {
  constructor() {
    super();
  }
  static make(...args) {
    throw new Error("Method not implemented! Use constructor!");
  }
};

// src/actions/message-actions/post/SkeetMessageActions.ts
var CreateSkeetMessageAction = class _CreateSkeetMessageAction extends AbstractMessageAction {
  constructor(skeetText) {
    super();
    this.skeetText = skeetText;
  }
  static make(skeetText) {
    return new _CreateSkeetMessageAction(skeetText);
  }
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  async handle(handlerAgent, message) {
    await CreateSkeetAction.make(this.skeetText).handle(handlerAgent);
  }
};
var CreateSkeetWithGeneratedTextAction = class _CreateSkeetWithGeneratedTextAction extends AbstractMessageAction {
  constructor(textGenerator) {
    super();
    this.textGenerator = textGenerator;
  }
  static make(textGenerator) {
    return new _CreateSkeetWithGeneratedTextAction(textGenerator);
  }
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  async handle(handlerAgent, message) {
    await handlerAgent.createSkeet(
      this.textGenerator(handlerAgent, message)
    );
  }
};
var ReplyToSkeetAction = class _ReplyToSkeetAction extends AbstractMessageAction {
  constructor(replyText) {
    super();
    this.replyText = replyText;
  }
  static make(replyText) {
    return new _ReplyToSkeetAction(replyText);
  }
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  async handle(handlerAgent, message) {
    const reply = handlerAgent.generateReplyFromMessage(message);
    await handlerAgent.createSkeet(this.replyText, reply);
  }
};
var ReplyToSkeetWithGeneratedTextAction = class _ReplyToSkeetWithGeneratedTextAction extends AbstractMessageAction {
  constructor(textGenerator) {
    super();
    this.textGenerator = textGenerator;
  }
  static make(textGenerator) {
    return new _ReplyToSkeetWithGeneratedTextAction(textGenerator);
  }
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  async handle(handlerAgent, message) {
    const reply = handlerAgent.generateReplyFromMessage(message);
    await handlerAgent.createSkeet(
      this.textGenerator(handlerAgent, message),
      reply
    );
  }
};

// src/handlers/message-handlers/premade-handlers/OfflineHandler.ts
var OfflineHandler = class _OfflineHandler extends MessageHandler {
  constructor(handlerAgent, command, response = "Bot functionality offline") {
    super(
      [new InputIsCommandValidator(command, false)],
      [new ReplyToSkeetAction(response)],
      handlerAgent
    );
    this.handlerAgent = handlerAgent;
    this.command = command;
    this.response = response;
  }
  static make(handlerAgent, command, response = void 0) {
    return new _OfflineHandler(handlerAgent, command, response);
  }
  // TODO Update to use JetstreamEventCommit
  async handle(handlerAgent, message) {
    return super.handle(this.handlerAgent, message);
  }
};

// src/validations/TestValidator.ts
var TestValidator = class _TestValidator extends AbstractValidator {
  constructor(shouldPass) {
    super();
    this.shouldPass = shouldPass;
  }
  static make(shouldPass) {
    return new _TestValidator(shouldPass);
  }
  async handle(handlerAgent) {
    return this.shouldPass;
  }
};

// src/validations/LogicalValidators.ts
var SimpleFunctionValidator = class _SimpleFunctionValidator extends AbstractValidator {
  constructor(triggerValidator) {
    super();
    this.triggerValidator = triggerValidator;
  }
  static make(triggerValidator) {
    return new _SimpleFunctionValidator(triggerValidator);
  }
  async handle(handlerAgent, ...args) {
    return await this.triggerValidator(handlerAgent, ...args);
  }
};
var OrValidator = class _OrValidator extends AbstractValidator {
  constructor(validators) {
    super();
    this.validators = validators;
  }
  static make(validators) {
    return new _OrValidator(validators);
  }
  async handle(handlerAgent, ...args) {
    let willTrigger = false;
    for (const validator of this.validators) {
      const currentValidatorWillTrigger = await validator.shouldTrigger(
        handlerAgent,
        ...args
      );
      if (currentValidatorWillTrigger) {
        willTrigger = true;
      }
    }
    return willTrigger;
  }
};

// src/validations/interval-validators/IsSpecifiedTimeValidator.ts
var IsSpecifiedTimeValidator = class _IsSpecifiedTimeValidator extends AbstractValidator {
  timezones = [];
  matchingTimezones = [];
  times;
  constructor(...times) {
    super();
    this.times = times;
  }
  static make(...times) {
    return new _IsSpecifiedTimeValidator(...times);
  }
  async handle(handlerAgent) {
    const timezones = {
      totalTimezones: 0
    };
    this.times.forEach((time) => {
      if (!isTimeInHHMMFormat(time)) {
        DebugLog.error(
          "Time Validator",
          `${time} is not in a valid format`
        );
        return;
      }
      timezones[time] = getTimezonesWhereItIsAGivenTime(time);
      timezones.totalTimezones = timezones.totalTimezones + timezones[time].length;
    });
    return timezones.totalTimezones > 0;
  }
};

// src/validations/interval-validators/IsFourTwentyValidator.ts
var IsFourTwentyValidator = class _IsFourTwentyValidator extends AbstractValidator {
  timezones = [];
  matchingTimezones = [];
  constructor() {
    super();
  }
  static make() {
    return new _IsFourTwentyValidator();
  }
  async handle(handlerAgent) {
    const timezones = _IsFourTwentyValidator.getTimezonesWhereItIsFourTwenty();
    return timezones.totalTimezones > 0;
  }
  static getTimezonesWhereItIsFourTwenty() {
    const timezonesAM = getTimezonesWhereItIsAGivenTime("04:20");
    const timezonesPM = getTimezonesWhereItIsAGivenTime("16:20");
    return {
      timezonesAM,
      timezonesPM,
      totalTimezones: timezonesAM.length + timezonesPM.length
    };
  }
};

// src/validations/message-validators/GenericValidators.ts
var ActionTakenByUserValidator = class _ActionTakenByUserValidator extends AbstractMessageValidator {
  constructor(userDid) {
    super();
    this.userDid = userDid;
  }
  static make(userDid) {
    return new _ActionTakenByUserValidator(userDid);
  }
  async handle(handlerAgent, message) {
    return this.userDid === message.did;
  }
};

// src/validations/message-validators/post/PostValidators.ts
var PostedByUserValidator = class _PostedByUserValidator extends AbstractMessageValidator {
  constructor(userDid) {
    super();
    this.userDid = userDid;
  }
  static make(userDid) {
    return new _PostedByUserValidator(userDid);
  }
  async handle(handlerAgent, message) {
    return this.userDid === message.did && message.commit.collection == "app.bsky.feed.post";
  }
};
var ReplyingToBotValidator = class _ReplyingToBotValidator extends AbstractMessageValidator {
  constructor() {
    super();
  }
  static make() {
    return new _ReplyingToBotValidator();
  }
  async handle(handlerAgent, message) {
    if (!message.commit.record?.reply) return false;
    const replyingToDid = handlerAgent.getDIDFromUri(
      message.commit.record.reply?.parent.uri
    );
    return handlerAgent.getDid === replyingToDid && message.commit.collection == "app.bsky.feed.post";
  }
};
var IsReplyValidator = class _IsReplyValidator extends AbstractMessageValidator {
  constructor() {
    super();
  }
  static make() {
    return new _IsReplyValidator();
  }
  async handle(handlerAgent, message) {
    return handlerAgent.hasPostReply(message);
  }
};
var IsNewPost = class _IsNewPost extends AbstractMessageValidator {
  constructor() {
    super();
  }
  static make() {
    return new _IsNewPost();
  }
  async handle(handlerAgent, message) {
    if (!message.commit.record) return false;
    const createdAt = new Date(message?.commit.record?.createdAt);
    const now = /* @__PURE__ */ new Date();
    const oneDay = 24 * 60 * 60 * 1e3;
    return now.getTime() - createdAt.getTime() < oneDay;
  }
};

// src/validations/message-validators/follow/FollowValidators.ts
var NewFollowerForUserValidator = class _NewFollowerForUserValidator extends AbstractMessageValidator {
  constructor(userDid) {
    super();
    this.userDid = userDid;
  }
  static make(userDid = void 0) {
    return new _NewFollowerForUserValidator(userDid);
  }
  async handle(handlerAgent, message) {
    if (!this.userDid) {
      return handlerAgent.getDid === message?.commit?.record?.subject;
    }
    return this.userDid === message?.commit?.record?.subject;
  }
};
var NewFollowFromUserValidator = class _NewFollowFromUserValidator extends AbstractMessageValidator {
  constructor(userDid) {
    super();
    this.userDid = userDid;
  }
  static make(userDid = void 0) {
    return new _NewFollowFromUserValidator(userDid);
  }
  async handle(handlerAgent, message) {
    if (!this.userDid) {
      return handlerAgent.getDid === message.did;
    }
    return this.userDid === message.did;
  }
};
var UserFollowedValidator = class extends NewFollowFromUserValidator {
};

// src/validations/message-validators/repost/RepostValidators.ts
var RepostByUser = class _RepostByUser extends AbstractMessageValidator {
  constructor(userDid, postUri) {
    super();
    this.userDid = userDid;
    this.postUri = postUri;
  }
  static make(userDid = void 0, postUri = void 0) {
    return new _RepostByUser(userDid, postUri);
  }
  async handle(handlerAgent, message) {
    if (!message.commit.record?.subject) return false;
    if (typeof message.commit.record?.subject == "string") return false;
    const uri = message.commit.record?.subject.uri;
    if (this.postUri) {
      if (uri != this.postUri) return false;
    }
    if (!this.userDid) {
      return handlerAgent.getDid === message.did;
    }
    return this.userDid === message.did;
  }
};
var RepostOfUser = class _RepostOfUser extends AbstractMessageValidator {
  constructor(userDid, postUri) {
    super();
    this.userDid = userDid;
    this.postUri = postUri;
  }
  static make(userDid = void 0, postUri = void 0) {
    return new _RepostOfUser(userDid, postUri);
  }
  async handle(handlerAgent, message) {
    if (!message.commit.record?.subject) return false;
    if (typeof message.commit.record?.subject == "string") return false;
    const uri = message.commit.record?.subject.uri;
    if (this.postUri) {
      if (uri != this.postUri) return false;
    }
    const postDid = handlerAgent.getDIDFromUri(uri);
    if (!this.userDid) {
      return handlerAgent.getDid === postDid;
    }
    return this.userDid === postDid;
  }
};
var RepostOfPost = class _RepostOfPost extends AbstractMessageValidator {
  constructor(postUri) {
    super();
    this.postUri = postUri;
  }
  static make(postUri) {
    return new _RepostOfPost(postUri);
  }
  async handle(handlerAgent, message) {
    if (typeof message.commit.record?.subject == "string") return false;
    if (!message.commit.record?.subject) return false;
    const uri = message.commit.record?.subject.uri;
    return uri == this.postUri;
  }
};

// src/validations/message-validators/like/LikeUserValidators.ts
var LikeByUser = class _LikeByUser extends AbstractMessageValidator {
  constructor(userDid, postUri) {
    super();
    this.userDid = userDid;
    this.postUri = postUri;
  }
  static make(userDid = void 0, postUri = void 0) {
    return new _LikeByUser(userDid, postUri);
  }
  async handle(handlerAgent, message) {
    if (!message.commit.record?.subject) return false;
    if (typeof message.commit.record?.subject == "string") return false;
    const uri = message.commit.record?.subject.uri;
    if (this.postUri) {
      if (uri != this.postUri) return false;
    }
    if (!this.userDid) {
      return handlerAgent.getDid === message.did;
    }
    return this.userDid === message.did;
  }
};
var LikeOfUser = class _LikeOfUser extends AbstractMessageValidator {
  constructor(userDid, postUri) {
    super();
    this.userDid = userDid;
    this.postUri = postUri;
  }
  static make(userDid = void 0, postUri = void 0) {
    return new _LikeOfUser(userDid, postUri);
  }
  async handle(handlerAgent, message) {
    if (!message.commit.record?.subject) return false;
    if (typeof message.commit.record?.subject == "string") return false;
    const uri = message.commit.record?.subject.uri;
    if (this.postUri) {
      if (uri != this.postUri) return false;
    }
    const postDid = handlerAgent.getDIDFromUri(uri);
    if (!this.userDid) {
      return handlerAgent.getDid === postDid;
    }
    return this.userDid === postDid;
  }
};
var LikeOfPost = class _LikeOfPost extends AbstractMessageValidator {
  constructor(postUri) {
    super();
    this.postUri = postUri;
  }
  static make(postUri) {
    return new _LikeOfPost(postUri);
  }
  async handle(handlerAgent, message) {
    if (typeof message.commit.record?.subject == "string") return false;
    if (!message.commit.record?.subject) return false;
    const uri = message.commit.record?.subject.uri;
    return uri == this.postUri;
  }
};

// src/validations/message-validators/like/LikeCountValidators.ts
var PostLikesValidator = class _PostLikesValidator extends AbstractMessageValidator {
  constructor(postUri, comparisonType, likeCount, likeCountMin, likeCountMax) {
    super();
    this.postUri = postUri;
    this.comparisonType = comparisonType;
    this.likeCount = likeCount;
    this.likeCountMin = likeCountMin;
    this.likeCountMax = likeCountMax;
    if (this.comparisonType !== "between" && this.likeCount === void 0) {
      throw new Error(
        "likeCount is required for non-between comparisons"
      );
    }
    if (this.comparisonType === "between" && (this.likeCountMin === void 0 || this.likeCountMax === void 0)) {
      throw new Error(
        "likeCountMin and likeCountMax are required for between comparisons"
      );
    }
  }
  static make(postUri, comparisonType, likeCount, likeCountMin, likeCountMax) {
    return new _PostLikesValidator(
      postUri,
      comparisonType,
      likeCount,
      likeCountMin,
      likeCountMax
    );
  }
  async handle(handlerAgent, message) {
    const likes = await handlerAgent.getPostLikeCount(this.postUri);
    switch (this.comparisonType) {
      case "equal":
        return likes === this.likeCount;
      case "greaterThan":
        return likes > this.likeCount;
      case "lessThan":
        return likes < this.likeCount;
      case "between":
        return (
          // @ts-ignore
          likes >= this.likeCountMin && // @ts-ignore
          likes <= this.likeCountMax
        );
    }
  }
};

// src/actions/FunctionAction.ts
var FunctionAction = class _FunctionAction extends AbstractAction {
  constructor(actionFunction) {
    super();
    this.actionFunction = actionFunction;
  }
  static make(actionFunction) {
    return new _FunctionAction(actionFunction);
  }
  async handle(handlerAgent, ...args) {
    await this.actionFunction(handlerAgent, ...args);
  }
};

// src/actions/standard-bsky-actions/ReskeetActions.ts
var CreateReskeetAction = class _CreateReskeetAction extends AbstractAction {
  constructor(skeetUri, skeetCid) {
    super();
    this.skeetUri = skeetUri;
    this.skeetCid = skeetCid;
  }
  static make(skeetUri, skeetCid) {
    return new _CreateReskeetAction(skeetUri, skeetCid);
  }
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  async handle(handlerAgent, ...args) {
    const uri = AbstractAction.getStringOrFunctionReturn(
      this.skeetUri,
      handlerAgent,
      ...args
    );
    const cid = AbstractAction.getStringOrFunctionReturn(
      this.skeetCid,
      handlerAgent,
      ...args
    );
    await handlerAgent.reskeetSkeet(uri, cid);
  }
};
var DeleteReskeetAction = class _DeleteReskeetAction extends AbstractAction {
  constructor(skeetUri) {
    super();
    this.skeetUri = skeetUri;
  }
  static make(skeetUri) {
    return new _DeleteReskeetAction(skeetUri);
  }
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  async handle(handlerAgent, ...args) {
    const uri = AbstractAction.getStringOrFunctionReturn(
      this.skeetUri,
      handlerAgent,
      ...args
    );
    await handlerAgent.unreskeetSkeet(uri);
  }
};

// src/actions/standard-bsky-actions/FollowActions.ts
var CreateFollowAction = class _CreateFollowAction extends AbstractAction {
  constructor(userDid) {
    super();
    this.userDid = userDid;
  }
  static make(userDid) {
    return new _CreateFollowAction(userDid);
  }
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  async handle(handlerAgent, ...args) {
    const did = AbstractAction.getStringOrFunctionReturn(
      this.userDid,
      handlerAgent,
      ...args
    );
    await handlerAgent.followUser(did);
  }
};
var DeleteFollowAction = class _DeleteFollowAction extends AbstractAction {
  constructor(userDid) {
    super();
    this.userDid = userDid;
  }
  static make(userDid) {
    return new _DeleteFollowAction(userDid);
  }
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  async handle(handlerAgent, ...args) {
    const did = AbstractAction.getStringOrFunctionReturn(
      this.userDid,
      handlerAgent,
      ...args
    );
    await handlerAgent.unfollowUser(did);
  }
};

// src/actions/message-actions/TestAction.ts
var TestMessageAction = class extends AbstractMessageAction {
  async handle(handlerAgent, message) {
    DebugLog.info("Working", "working");
  }
};

// src/actions/message-actions/MessageLoggingActions.ts
var LogMessageAction = class _LogMessageAction extends AbstractMessageAction {
  // eslint-disable-next-line @typescript-eslint/no-unused-vars,  @typescript-eslint/no-explicit-any
  static make() {
    return new _LogMessageAction();
  }
  async handle(handlerAgent, message) {
    console.log(message);
  }
};

// src/subscriptions/AbstractSubscription.ts
var AbstractSubscription = class {
  constructor(handlers) {
    this.handlers = handlers;
  }
  restartSubscription() {
    this.stopSubscription();
    this.createSubscription();
    return this;
  }
};

// src/subscriptions/IntervalSubscription.ts
var IntervalSubscription = class extends AbstractSubscription {
  constructor(intervalHandlers) {
    super(intervalHandlers);
    this.intervalHandlers = intervalHandlers;
  }
  _intervals = [];
  get intervals() {
    return this._intervals;
  }
  createSubscription() {
    this.intervalHandlers.forEach((intervalCollection) => {
      this._intervals.push(
        setInterval(async () => {
          for (const handler of intervalCollection.handlers) {
            await handler.handle(void 0);
          }
        }, intervalCollection.intervalSeconds * 1e3)
      );
    });
    return this;
  }
  stopSubscription() {
    this.intervals.forEach((interval) => {
      clearInterval(interval);
    });
    this._intervals = [];
    return this;
  }
};

// src/subscriptions/firehose/JetstreamSubscription.ts
var import_ws = __toESM(require("ws"));
var JetstreamSubscription = class extends AbstractSubscription {
  // seconds
  /**
   * Creates a new instance of the Firehose Subscription.
   *
   * @param {JetstreamSubscriptionHandlers} handlerControllers - An array of handler controllers.
   * @param {string} wsURL - The WebSocket URL to connect to. Defaults to `wss://bsky.network`.
   */
  constructor(handlerControllers, wsURL = "ws://localhost:6008/subscribe") {
    super(handlerControllers);
    this.handlerControllers = handlerControllers;
    this.wsURL = wsURL;
    this.generateWsURL();
    DebugLog.info("FIREHOSE", `Websocket URL: ${this.wsURL}`);
  }
  //@ts-ignore
  wsClient;
  lastMessageTime;
  restart = false;
  restartDelay = 5;
  set setWsURL(url) {
    this.wsURL = url;
  }
  generateWsURL() {
    const properties = ["post", "like", "repost", "follow"];
    const queryParams = properties.filter((property) => Boolean(this.handlerControllers[property])).map((property) => {
      const prefix = property === "follow" ? "graph" : "feed";
      return `wantedCollections=app.bsky.${prefix}.${property}`;
    });
    if (queryParams.length > 0) {
      this.setWsURL = `${this.wsURL}?${queryParams.join("&")}`;
    }
  }
  /**
   *
   */
  createSubscription() {
    DebugLog.warn("FIREHOSE", `Initializing`);
    this.wsClient = new import_ws.default(this.wsURL);
    this.wsClient.on("open", this.handleOpen);
    this.wsClient.on(
      "message",
      (data, isBinary) => {
        const message = data.toString();
        if (typeof message === "string") {
          const event = JSON.parse(message);
          if (event.kind === "commit") {
            switch (event.commit?.operation) {
              case "create":
                this.handleCreate(
                  event
                );
                break;
              case "delete":
                this.handleDelete(
                  event
                );
                break;
            }
          }
        }
      }
    );
    this.wsClient.on("close", () => {
      DebugLog.error("JETSTREAM", "Subscription Closed");
      this.restart = true;
      this.wsClient?.close();
      if (this.restart) {
        DebugLog.warn(
          "JETSTREAM",
          "Subscription restarting in 5 seconds"
        );
        setTimeout(() => {
          this.createSubscription();
          this.restart = false;
        }, this.restartDelay * 1e3);
      }
    });
    this.wsClient.on("error", (err) => {
      this.handleError(err);
    });
    return this;
  }
  handleOpen() {
    DebugLog.info("FIREHOSE", `Connection Opened`);
  }
  handleError(err) {
    console.log(err);
    DebugLog.error("FIREHOSE", `Error: ${err.message}`);
    this.restart = true;
  }
  stopSubscription(restart = false) {
    this.wsClient.close();
    this.restart = restart;
    return this;
  }
  // TODO There has got to be a better way to do this, I'm just to high to do it now
  handleCreate(createEvent) {
    switch (createEvent.commit.collection) {
      case "app.bsky.feed.post":
        this.handlerControllers.post?.c?.forEach(
          // @ts-ignore
          (handler) => {
            handler.handle(void 0, createEvent);
          }
        );
        break;
      case "app.bsky.feed.like":
        this.handlerControllers.like?.c?.forEach(
          (handler) => {
            handler.handle(void 0, createEvent);
          }
        );
        break;
      case "app.bsky.feed.repost":
        this.handlerControllers.repost?.c?.forEach(
          (handler) => {
            handler.handle(void 0, createEvent);
          }
        );
        break;
      case "app.bsky.graph.follow":
        this.handlerControllers.follow?.c?.forEach(
          (handler) => {
            handler.handle(void 0, createEvent);
          }
        );
        break;
    }
  }
  handleDelete(deleteEvent) {
    switch (deleteEvent.commit.collection) {
      case "app.bsky.feed.post":
        this.handlerControllers.post?.d?.forEach(
          (handler) => {
            handler.handle(void 0, deleteEvent);
          }
        );
        break;
      case "app.bsky.feed.like":
        this.handlerControllers.like?.d?.forEach(
          (handler) => {
            handler.handle(void 0, deleteEvent);
          }
        );
        break;
      case "app.bsky.feed.repost":
        this.handlerControllers.repost?.d?.forEach(
          (handler) => {
            handler.handle(void 0, deleteEvent);
          }
        );
        break;
      case "app.bsky.graph.follow":
        this.handlerControllers.follow?.d?.forEach(
          (handler) => {
            handler.handle(void 0, deleteEvent);
          }
        );
        break;
    }
  }
};

// src/agent/HandlerAgent.ts
var import_api = require("@atproto/api");

// src/utils/logging-utils.ts
function debugLog(action, message, level = "info") {
  const debug = process.env.DEBUG_LOG_ACTIVE === "true";
  const debugLevel = process.env.DEBUG_LOG_LEVEL ?? "error";
  if (debug) {
    if (level === "error") {
      console.log(`${nowDateTime()} | ${action} | ERROR | ${message}`);
    }
    if (level === "warn") {
      if (debugLevel === "warn" || debugLevel === "info") {
        console.log(`${nowDateTime()} | ${action} | WARN | ${message}`);
      }
    }
    if (level == "info") {
      if (debugLevel === "info") {
        console.log(`${nowDateTime()} | ${action} | INFO | ${message}`);
      }
    }
  }
}

// src/agent/HandlerAgent.ts
var import_node_fs = __toESM(require("fs"));
var HandlerAgent = class {
  /**
   *
   */
  constructor(agentName, handle, password, agent = void 0) {
    this.agentName = agentName;
    this.handle = handle;
    this.password = password;
    if (!agent) {
      this.agent = this.initializeBskyAgent();
    } else {
      this.agent = agent;
      this.setDid = agent.session?.did;
      this.setSession = agent.session;
    }
  }
  did;
  session;
  agent;
  //region INIT Agent
  /**
   *
   */
  initializeBskyAgent() {
    return new import_api.BskyAgent({
      service: "https://bsky.social/",
      persistSession: (evt, sess) => {
        this.setDid = sess?.did;
        this.setSession = sess;
      }
    });
  }
  /**
   *
   */
  async authenticate() {
    if (!this.agent) {
      this.agent = this.initializeBskyAgent();
    }
    if (import_node_fs.default.existsSync(this.getSessionLocation())) {
      DebugLog.warn("AGENT", "Existing session. Loading session");
      const loadedSession = await this.loadSessionData();
      if (loadedSession) {
        this.setSession = loadedSession;
      }
    }
    if (this.agent && this.session === void 0) {
      DebugLog.warn("AGENT", "No existing session. creating session");
      await this.agent.login({
        identifier: this.handle,
        password: this.password
      });
      if (!this.session) {
        throw new Error(
          "Could not retrieve bluesky session data for reply bot"
        );
      } else {
        debugLog("AGENT", `${this.agentName} is authenticated!`);
      }
    }
    if (this.session !== void 0) {
      await this.agent.resumeSession(this.session);
      if (!this.agent) {
        throw new Error(`Could not get agent from ${this.agentName}`);
      }
      return this;
    }
  }
  getSessionLocation() {
    const path = process.env?.SESSION_DATA_PATH ?? ".";
    return `${path}/${this.agentName}-session.json`;
  }
  async saveSessionData(session) {
    const sessionLocation = this.getSessionLocation();
    return new Promise((resolve, reject) => {
      import_node_fs.default.writeFile(sessionLocation, JSON.stringify(session), (err) => {
        if (err) {
          DebugLog.error(
            "AGENT",
            `Failed to save session data. ${err.message}`
          );
          reject(new Error("Failed to save"));
        } else {
          resolve();
        }
      });
    });
  }
  async loadSessionData() {
    const sessionLocation = this.getSessionLocation();
    return new Promise((resolve, reject) => {
      import_node_fs.default.readFile(sessionLocation, "utf8", (err, data) => {
        if (err) {
          DebugLog.error(
            "AGENT",
            `Failed to read session data. ${err.message}`
          );
          resolve(void 0);
        } else {
          try {
            resolve(JSON.parse(data));
          } catch (parseError) {
            DebugLog.error(
              "AGENT",
              `Failed to parse session data. ${parseError}`
            );
            resolve(void 0);
          }
        }
      });
    });
  }
  //endregion
  //region Follower Interactions
  /**
   * getProfile
   */
  async getProfile(did) {
    const response = await this.agent?.getProfile({ actor: did });
    return response?.data;
  }
  /**
   *
   */
  async getFollows(userDID = void 0, cursor = void 0, limit = 50) {
    if (userDID === void 0) {
      userDID = this.getDid;
    }
    const body = {
      actor: userDID,
      cursor,
      limit
    };
    const resp = await this.agent?.getFollows(body);
    return resp?.data;
  }
  /**
   *
   */
  async getFollowers(userDID = void 0, cursor = void 0, limit = 50) {
    if (userDID === void 0) {
      userDID = this.getDid;
    }
    const body = {
      actor: userDID,
      cursor,
      limit
    };
    const resp = await this.agent?.getFollowers(body);
    return resp?.data;
  }
  /**
   *
   */
  async isFollowing(userDID) {
    const followProfile = await this.getProfile(userDID);
    if (!followProfile) {
      return false;
    }
    const viewer = followProfile?.viewer;
    if (!viewer?.following) {
      return false;
    }
    return true;
  }
  /**
   *
   */
  async isFollowedBy(userDID) {
    const followProfile = await this.getProfile(userDID);
    if (!followProfile) {
      return false;
    }
    const viewer = followProfile?.viewer;
    if (!viewer?.followedBy) {
      return false;
    }
    return true;
  }
  /**
   *
   */
  async followUser(userDID) {
    await this.agent?.follow(userDID);
    return true;
  }
  /**
   *
   */
  async unfollowUser(userDID) {
    const followProfile = await this.getProfile(userDID);
    if (!followProfile) {
      return false;
    }
    const followLink = followProfile?.viewer?.following;
    if (followLink) {
      await this.agent?.deleteFollow(followLink);
      return true;
    }
    return false;
  }
  //endregion
  //region Follow Helpers
  //
  // /**
  //  *
  //  * @param follows
  //  */
  // extractDIDsFromProfiles(follows: ProfileView[]): string[] {
  //     return follows.map((item) => item.did);
  // }
  //
  // getRecordForDid(
  //     targetDid: string,
  //     data: ProfileView[]
  // ): ProfileView | undefined {
  //     return data.find((item) => item.did === targetDid);
  // }
  //endregion
  //region Post interactions
  /**
   *
   * @param details
   */
  async post(details) {
    return await this?.agent?.post(details);
  }
  /**
   *
   */
  async createSkeet(newPostDetails, skeetReply = void 0) {
    const replyText = new import_api.RichText({
      text: newPostDetails
    });
    if (this.getAgent !== void 0) {
      await replyText.detectFacets(this.getAgent);
    }
    const record = {
      text: replyText.text
    };
    if (skeetReply !== void 0) {
      record.reply = skeetReply;
    }
    if (replyText.facets !== void 0) {
      record.facets = replyText.facets;
    }
    return await this.agent?.post(record);
  }
  /**
   *
   */
  async deleteSkeet(skeetURI) {
    await this.agent?.deletePost(skeetURI);
    return true;
  }
  /**
   *
   */
  async likeSkeet(skeetURI, skeetCID) {
    await this.agent?.like(skeetURI, skeetCID);
    return true;
  }
  /**
   *
   */
  async unlikeSkeet(skeetUri) {
    const likeUri = await this.findLikeRecord(skeetUri);
    if (likeUri == "") {
      return false;
    }
    await this.agent?.deleteLike(likeUri);
    return true;
  }
  /**
   *
   */
  async reskeetSkeet(skeetURI, skeetCID) {
    await this.agent?.repost(skeetURI, skeetCID);
    return true;
  }
  /**
   *
   */
  async unreskeetSkeet(skeetUri) {
    const reskeetUri = await this.findRepostRecord(skeetUri);
    if (reskeetUri == "") {
      return false;
    }
    await this.agent?.deleteRepost(reskeetUri);
    return true;
  }
  //endregion
  //region Post Helpers
  /**
   * Finds a record that is similar to a given skeet URI.
   *
   * @param {string} skeetUri - The skeet URI to find a similar record for.
   * @param {string} [cursor=undefined] - The optional cursor to paginate results.
   * @param {number} [attempt=1] - The number of attempts made to find the record.
   * @returns {Promise<string>} A promise that resolves to the ID of the found record.
   */
  async findLikeRecord(skeetUri, cursor = void 0, attempt = 1) {
    return this.findSpecificRecord(
      "app.bsky.feed.like",
      "like",
      skeetUri,
      cursor,
      attempt
    );
  }
  /**
   * Finds a repost record based on the given parameters.
   * @param {string} skeetUri - The skeet URI to search for.
   * @param {string | undefined} cursor - Optional cursor for pagination.
   * @param {number} attempt - The attempt number for the search.
   * @return {Promise<string>} - A Promise that resolves to the found repost record.
   */
  async findRepostRecord(skeetUri, cursor = void 0, attempt = 1) {
    return this.findSpecificRecord(
      "app.bsky.feed.repost",
      "repost",
      skeetUri,
      cursor,
      attempt
    );
  }
  /**
   * Finds a specific record in a collection.
   *
   * @param {string} collectionType - The type of collection to search in.
   * @param {string} errorName - The name of the error associated with the record.
   * @param {string} skeetUri - The URI of the record to find.
   * @param {string[]} cursor - The cursor used for pagination (optional).
   * @param {number} attempt - The attempt number (optional).
   *
   * @return {Promise<string>} - A promise that resolves to the URI of the found record.
   */
  async findSpecificRecord(collectionType, errorName, skeetUri, cursor = void 0, attempt = 1) {
    const params = {
      repo: this.getDid,
      collection: collectionType,
      limit: 100
    };
    if (cursor !== void 0) {
      params["cursor"] = cursor;
    }
    const recordsResponse = await this.agent?.api.com.atproto.repo.listRecords(params, {});
    if (recordsResponse == void 0) {
      DebugLog.error(
        "Handler Agent",
        `Failed to retrieve ${errorName} records`
      );
      return "";
    }
    const records = recordsResponse.data.records;
    cursor = recordsResponse.data.cursor;
    const record = records.find(
      // @ts-ignore
      (record2) => record2.value.subject.uri === skeetUri
    );
    if (record == null) {
      DebugLog.info("Handler Agent", `Attempt ${attempt} to find record`);
      if (attempt >= 25) {
        DebugLog.error(
          "Handler Agent",
          `Failed to retrieve ${errorName} record`
        );
        return "";
      }
      return await this.findSpecificRecord(
        collectionType,
        errorName,
        skeetUri,
        cursor,
        attempt + 1
      );
    }
    return record.uri;
  }
  /**
   *
   */
  getDIDFromUri(uri) {
    return (uri.match(/did:[^/]*/) || [])[0];
  }
  /**
   *
   */
  postedByAgent(message) {
    return message.did === this.getDid;
  }
  /**
   *
   */
  generateURIFromCreateMessage(message) {
    return `at://${message.did}/app.bsky.feed.post/${message.commit.rkey}`;
  }
  /**
   *
   */
  generateReplyFromMessage(event) {
    let reply;
    if (typeof event.commit.record?.subject == "string") {
      return {
        root: {
          uri: "",
          cid: ""
        },
        parent: {
          uri: "",
          cid: ""
        }
      };
    }
    const parentReply = {
      // @ts-ignore
      cid: event.commit.cid,
      uri: `at://${event.did}/app.bsky.feed.post/${event.commit.rkey}`
    };
    if (event.commit.record?.reply) {
      reply = {
        root: event.commit.record.reply.root,
        parent: parentReply
      };
    } else {
      reply = {
        root: parentReply,
        parent: parentReply
      };
    }
    return reply;
  }
  hasPostReply(message) {
    if (!message.commit.record) return false;
    return "reply" in message.commit.record && message.commit?.record?.reply !== void 0;
  }
  getPostReply(message) {
    return message?.commit?.record?.reply;
  }
  async getPostLikeCount(postUri) {
    return await this.getPostCount(postUri, "like");
  }
  async getPostRepostCount(postUri) {
    return await this.getPostCount(postUri, "repost");
  }
  async getPostReplyCount(postUri) {
    return await this.getPostCount(postUri, "reply");
  }
  async getPostQuoteCount(postUri) {
    return await this.getPostCount(postUri, "quote");
  }
  async getPostCount(postUri, countType) {
    const resp = await this.agent?.getPostThread({
      uri: postUri
    });
    if (!resp) return -1;
    const post = resp.data.thread.post;
    switch (countType) {
      case "like":
        return post.likeCount;
      case "repost":
        return post.repostCount;
      case "reply":
        return post.replyCount;
      case "quote":
        return post.quoteCount;
    }
  }
  //endregion
  // region class prop getters and setters
  /**
   * Setter for agent.
   * @param agent
   */
  set setAgent(agent) {
    this.agent = agent;
  }
  /**
   * Getter for agent.
   * @return {BskyAgent} The current value of agent.
   */
  get getAgent() {
    return this.agent;
  }
  /**
   * Setter for agentName.
   * @param {string} value - The new value for agentName.
   */
  set setAgentName(value) {
    this.agentName = value;
  }
  /**
   * Getter for agentName.
   * @return {string} The current value of agentName.
   */
  get getAgentName() {
    return this.agentName;
  }
  /**
   * Setter for handle.
   * @param {string} value - The new value for handle.
   */
  set setHandle(value) {
    this.handle = value;
  }
  /**
   * Getter for handle.
   * @return {string} The current value of handle.
   */
  get getHandle() {
    return this.handle;
  }
  /**
   * Setter for password.
   * @param {string} value - The new value for password.
   */
  set setPassword(value) {
    this.password = value;
  }
  /**
   * Getter for password.
   * @return {string} The current value of password.
   */
  get getPassword() {
    return this.password;
  }
  /**
   * Setter for did.
   * @param {string} value - The new value for did.
   */
  set setDid(value) {
    this.did = value;
  }
  /**
   * Getter for did.
   * @return {string} The current value of did.
   */
  get getDid() {
    if (!this.did) {
      return "";
    }
    return this.did;
  }
  /**
   * Setter for session.
   * @param sess
   */
  set setSession(sess) {
    this.session = sess;
    if (this.session !== void 0) {
      DebugLog.warn("AGENT", "Saving session");
      this.saveSessionData(this.session);
    }
  }
  /**
   * Getter for session.
   * @return {any} The current value of session.
   */
  get getSession() {
    if (!this.session) {
      return false;
    }
    return this.session;
  }
  //endregion
};

// src/types/factories/AbstractTypeFactory.ts
var AbstractTypeFactory = class {
  constructor() {
  }
  static factory() {
    throw new Error("Method Not Implemented! Use constructor.");
  }
  static make() {
    throw new Error("Method Not Implemented! Use constructor.");
  }
  create() {
    throw new Error("Method Not Implemented! Use constructor.");
  }
};
var TestFactory = class extends AbstractTypeFactory {
};

// src/types/factories/RecordFactories.ts
var JetstreamRecordFactory = class _JetstreamRecordFactory extends AbstractTypeFactory {
  record;
  constructor() {
    super();
    this.record = {
      $type: "app.bsky.feed.like",
      createdAt: "",
      subject: void 0
    };
  }
  static factory() {
    return new _JetstreamRecordFactory();
  }
  static make() {
    return _JetstreamRecordFactory.factory().create();
  }
  create() {
    return this.record;
  }
  type(inputType) {
    this.record.$type = inputType;
    return this;
  }
  isLike() {
    this.record.$type = "app.bsky.feed.like";
    return this;
  }
  isRepost() {
    this.record.$type = "app.bsky.feed.repost";
    return this;
  }
  isFollow(followedDid = void 0) {
    this.record.$type = "app.bsky.graph.follow";
    if (followedDid !== void 0) {
      this.record.subject = followedDid;
    }
    return this;
  }
  subject(inputSubject) {
    this.record.subject = inputSubject;
    return this;
  }
};
var NewSkeetRecordFactory = class _NewSkeetRecordFactory extends AbstractTypeFactory {
  record;
  constructor() {
    super();
    this.record = {
      $type: "app.bsky.feed.post",
      createdAt: Date.now().toString(),
      embed: void 0,
      facets: void 0,
      langs: void 0,
      text: "example text",
      reply: void 0
    };
  }
  static factory() {
    return new _NewSkeetRecordFactory();
  }
  static make() {
    return _NewSkeetRecordFactory.factory().create();
  }
  create() {
    return this.record;
  }
  reply(reply = void 0) {
    if (reply === void 0) {
      this.record.reply = ReplyFactory.make();
    } else {
      this.record.reply = reply;
    }
    return this;
  }
  text(text) {
    this.record.text = text;
    return this;
  }
};
var CreateSkeetRecordFactory = class _CreateSkeetRecordFactory extends AbstractTypeFactory {
  skeetRecordObject;
  /**
   * Create a new instance of the CreateSkeetRecordFactory.
   *
   * @constructor
   */
  constructor() {
    super();
    this.skeetRecordObject = {
      $type: "app.bsky.feed.post",
      createdAt: Date.now().toString(),
      embed: void 0,
      facets: void 0,
      langs: void 0,
      reply: void 0,
      text: ""
    };
  }
  /**
   * Factory method for creating an instance of CreateSkeetRecordFactory.
   *
   * @returns {CreateSkeetRecordFactory} The new instance of CreateSkeetRecordFactory.
   */
  static factory() {
    return new _CreateSkeetRecordFactory();
  }
  static make() {
    return _CreateSkeetRecordFactory.factory().create();
  }
  /**
   * Creates a new {CreateSkeetRecord} object from the factoru data.
   *
   * @returns {CreateSkeetRecord} The newly created {CreateSkeetRecord} object.
   */
  create() {
    return this.skeetRecordObject;
  }
  /**
   * Set the text for the Skeet JetstreamRecord object.
   *
   * @param {string} skeetText - The text to be set for the Skeet JetstreamRecord.
   * @return {CreateSkeetRecordFactory} - The update instance of CreateSkeetRecordFactory.
   */
  text(skeetText) {
    this.skeetRecordObject.text = skeetText;
    return this;
  }
  /**
   * Sets the reply value for a SkeetRecordFactory object.
   *
   * @param {JetstreamReply} skeetReply - The reply value to be set for the SkeetRecordFactory object.
   * @return {CreateSkeetRecordFactory} - The update instance of CreateSkeetRecordFactory.
   */
  reply(skeetReply) {
    this.skeetRecordObject.reply = skeetReply;
    return this;
  }
};
var JetstreamSubjectFactory = class _JetstreamSubjectFactory extends AbstractTypeFactory {
  subject;
  constructor() {
    super();
    this.subject = {
      cid: "",
      uri: ""
    };
  }
  static factory() {
    return new _JetstreamSubjectFactory();
  }
  static make() {
    return _JetstreamSubjectFactory.factory().create();
  }
  create() {
    return this.subject;
  }
  cid(inputCid) {
    this.subject.cid = inputCid;
    return this;
  }
  uri(inputUri) {
    this.subject.uri = inputUri;
    return this;
  }
};
var ReplyFactory = class _ReplyFactory extends AbstractTypeFactory {
  reply;
  constructor() {
    super();
    this.reply = {
      root: {
        uri: "",
        cid: ""
      },
      parent: {
        uri: "",
        cid: ""
      }
    };
  }
  static factory() {
    return new _ReplyFactory();
  }
  static make() {
    return _ReplyFactory.factory().create();
  }
  create() {
    return this.reply;
  }
  /**
   * Sets the root subject for the reply.
   *
   * @param {JetstreamSubject} replyRoot - The root subject for the reply.
   * @return {ReplyFactory} - The updated instance of the ReplyFactory.
   */
  root(replyRoot) {
    this.reply.root = replyRoot;
    return this;
  }
  /**
   * Sets the parent reply for the given subject.
   *
   * @param {JetstreamSubject} replyParent - The parent reply to be set.
   * @return {ReplyFactory} - The updated instance of the ReplyFactory.
   */
  parent(replyParent) {
    this.reply.parent = replyParent;
    return this;
  }
  // I like the `replyTo` function and think it could be good to use on the skeet actions? lets see where that goes
  /**
   * Sets the parent URI for replying to a message.
   *
   * @param {string} did - The decentralized identifier (DID) of the user.
   * @return {ReplyFactory} - The updated instance of the ReplyFactory.
   */
  replyTo(did) {
    this.reply.parent.uri = `at://${did}/app.bsky.feed.post/rkey`;
    return this;
  }
};

// src/types/factories/MessageFactories.ts
var JetstreamEventFactory = class _JetstreamEventFactory extends AbstractTypeFactory {
  eventObject;
  constructor() {
    super();
    this.eventObject = {
      did: "did:plc:example",
      kind: "commit",
      time_us: 0
    };
  }
  static factory() {
    return new _JetstreamEventFactory();
  }
  static make() {
    return _JetstreamEventFactory.factory().create();
  }
  create() {
    return this.eventObject;
  }
  fromDid(did) {
    this.eventObject.did = did;
    return this;
  }
  commit(commit = void 0) {
    this.eventObject.kind = "commit";
    if (commit === void 0) {
      this.eventObject.commit = JetstreamCommitFactory.make();
    } else {
      this.eventObject.commit = commit;
    }
    return this;
  }
};
var JetstreamCommitFactory = class _JetstreamCommitFactory extends AbstractTypeFactory {
  eventObject;
  constructor() {
    super();
    this.eventObject = {
      collection: "app.bsky.feed.post",
      operation: "create",
      rev: "examplerev",
      rkey: "examplerkey",
      cid: "examplecid",
      record: void 0
    };
  }
  static factory() {
    return new _JetstreamCommitFactory();
  }
  static make() {
    return _JetstreamCommitFactory.factory().create();
  }
  create() {
    return this.eventObject;
  }
  rkey(rkey) {
    this.eventObject.rkey = rkey;
    return this;
  }
  record(record) {
    this.eventObject.record = record;
    return this;
  }
  operation(operation) {
    this.eventObject.operation = operation;
    return this;
  }
  collection(collection) {
    this.eventObject.collection = collection;
    return this;
  }
  text(text) {
    if (this.eventObject.record == void 0) {
      this.eventObject.record = NewSkeetRecordFactory.factory().text(text).create();
    } else {
      const tempRecord = this.eventObject.record;
      tempRecord.text = text;
      this.eventObject.record = tempRecord;
    }
    return this;
  }
};
var JetstreamIdentityFactory = class _JetstreamIdentityFactory extends AbstractTypeFactory {
  eventObject;
  constructor() {
    super();
    this.eventObject = {
      did: "did:plc:example",
      handle: "handle.example",
      seq: 0,
      time: ""
    };
  }
  static factory() {
    return new _JetstreamIdentityFactory();
  }
  static make() {
    return _JetstreamIdentityFactory.factory().create();
  }
  create() {
    return this.eventObject;
  }
  handle(handle) {
    this.eventObject.handle = handle;
    return this;
  }
  sequence(seq) {
    this.eventObject.seq = seq;
    return this;
  }
};
var JetstreamAccountFactory = class _JetstreamAccountFactory extends AbstractTypeFactory {
  eventObject;
  constructor() {
    super();
    this.eventObject = {
      active: true,
      did: "did:plc:example",
      seq: 0,
      time: Date.now().toString()
    };
  }
  static factory() {
    return new _JetstreamAccountFactory();
  }
  static make() {
    return _JetstreamAccountFactory.factory().create();
  }
  create() {
    return this.eventObject;
  }
  deactivate() {
    this.eventObject.active = false;
    return this;
  }
  sequence(seq) {
    this.eventObject.seq = seq;
    return this;
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  AbstractAction,
  AbstractHandler,
  AbstractMessageAction,
  AbstractSubscription,
  AbstractTypeFactory,
  AbstractValidator,
  ActionTakenByUserValidator,
  BadBotHandler,
  CreateFollowAction,
  CreateLikeAction,
  CreateReskeetAction,
  CreateSkeetAction,
  CreateSkeetMessageAction,
  CreateSkeetRecordFactory,
  CreateSkeetWithGeneratedTextAction,
  DebugLog,
  DebugLogAction,
  DeleteFollowAction,
  DeleteLikeAction,
  DeleteReskeetAction,
  DeleteSkeetAction,
  FunctionAction,
  GoodBotHandler,
  HandlerAgent,
  InputContainsValidator,
  InputEqualsValidator,
  InputIsCommandValidator,
  InputStartsWithValidator,
  IntervalSubscription,
  IsBadBotValidator,
  IsFourTwentyValidator,
  IsGoodBotValidator,
  IsNewPost,
  IsReplyValidator,
  IsSpecifiedTimeValidator,
  JetstreamAccountFactory,
  JetstreamCommitFactory,
  JetstreamEventFactory,
  JetstreamIdentityFactory,
  JetstreamRecordFactory,
  JetstreamSubjectFactory,
  JetstreamSubscription,
  LikeByUser,
  LikeOfPost,
  LikeOfUser,
  LogInputTextAction,
  LogMessageAction,
  MessageHandler,
  NewFollowFromUserValidator,
  NewFollowerForUserValidator,
  NewSkeetRecordFactory,
  OfflineHandler,
  OrValidator,
  PostLikesValidator,
  PostedByUserValidator,
  ReplyFactory,
  ReplyToSkeetAction,
  ReplyToSkeetWithGeneratedTextAction,
  ReplyingToBotValidator,
  RepostByUser,
  RepostOfPost,
  RepostOfUser,
  SimpleFunctionValidator,
  TestAction,
  TestFactory,
  TestHandler,
  TestMessageAction,
  TestMessageHandler,
  TestValidator,
  UserFollowedValidator,
  containsNumbers,
  containsPunctuation,
  containsSpaces,
  debugLog,
  flattenTextUpdated,
  getHumanReadableDateTimeStamp,
  getTimezonesWhereItIsAGivenTime,
  isBadBotResponse,
  isGoodBotResponse,
  isTimeInHHMMFormat,
  nowDateTime,
  removeNumbers,
  removePunctuation,
  removeSpaces,
  trimCommandInput
});
//# sourceMappingURL=index.js.map